if (typeof(newWBOPartner) === "undefined") {
    var globalPartnerId = null;
    var globalStarterId = null;
    var log = [];

    var newwbopartner = function() {
        var rnd=new Date().getTime();
        var partnerParams = null;
        var partnerLoaded = 0;
        var XHR = ('onload' in new XMLHttpRequest()) ? XMLHttpRequest : XDomainRequest;
        var frame = null;
        var scriptURL = partnerScriptURL;
        var initPartnerId = null;
        var partnerIdShortcode = '[pps_partnerid]';

        this.setInitPartnerId = function (pid) {
            if (pid) {
                initPartnerId = pid;
            }
        };

        this.getUrlVars = function(url) {
            var vars = {};
            var parts = url.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
                vars[key] = value;
            });
            return vars;
        };

        this.linksAddPartnerId = function(pid,stid) {
            log.push("AddPartnerId started");
            log.push("pid = " + pid);
            log.push("scriptURL = " + scriptURL);
            if (pid || stid) {
                var elems = document.getElementsByTagName('a'), i;
                for (i in elems) {
                    if (elems[i] && elems[i].href) {
                        if (elems[i].href.indexOf(encodeURI(partnerIdShortcode)) !== -1) {
                            elems[i].href = elems[i].href.replaceAll(encodeURI(partnerIdShortcode), pid);
                        }
                        if (elems[i].href && elems[i].href.indexOf(scriptURL) !== -1) {
                            var urlvars = this.getUrlVars(elems[i].href);
                            if (urlvars["partnerID"] !== pid && urlvars["partnerid"] !== pid) {
                                if (elems[i].href.indexOf(pid) === -1) {
                                    if (elems[i].href.indexOf("/home/register") !== -1 || elems[i].href.indexOf("/home/product") !== -1 || elems[i].href.indexOf("/home/shop") !== -1 || elems[i].href.indexOf("/home/addproduct") !== -1) {
                                        if (elems[i].href.indexOf("?") === -1) {
                                            elems[i].href += "?";
                                        }
                                        else {
                                            elems[i].href += "&";
                                        }
                                        if (pid) {
                                            elems[i].href += "partnerID="+pid;
                                        }
                                        if (stid) {
                                            elems[i].href += "&starterID="+stid;
                                        }

                                    }
                                    else {
                                        if (elems[i].href.indexOf('?') === -1) {
                                            elems[i].href += "?";
                                        }
                                        else {
                                            elems[i].href += "&";
                                        }
                                        if (pid) {
                                            elems[i].href += "partnerID="+pid;
                                        }
                                        if (stid) {
                                            elems[i].href += "&starterID="+stid;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        };
        
        this.Send = function() {
            log.push("Send started");

            this.getParams = function () {
                objRes      = {};

                url = new URL(window.location.href);
                href = url.pathname;
                if (href.indexOf('/ba/') >= 0) {
                    href = href.split('/ba/');
                    href = href[1].trim();
                    if (href != '') {
                        objRes['partnerid'] = href;

                    }
                }
                else if (href.indexOf('/vp/') >= 0) {
                    href = href.split('/vp/');
                    href = href[1].trim();
                    if (href != '') {
                        objRes['partnerid'] = href;

                    }
                }
                else if (href.indexOf('/partner/') >= 0) {
                    href = href.split('/partner/');
                    href = href[1].trim();
                    if (href != '') {
                        objRes['partnerid'] = href;

                    }
                }
                else if (href.indexOf("/empfehlungsgeber/") >= 0) {
                    href = href.split("/empfehlungsgeber/");
                    href = href[1].trim();
                    if (href !== "") {
                        objRes["starterid"] = href;

                    }
                }
                else {
                    var strQuery = window.location.search,
                        strSearch   = strQuery.substr(1),
                        strPattern  = /([^=]+)=([^&]+)&?/ig,
                        arrMatch    = strPattern.exec(strSearch);
                    while (arrMatch != null) {
                        objRes[arrMatch[1]] = arrMatch[2];
                        arrMatch = strPattern.exec(strSearch);
                    }
                }

                if(!objRes['partnerid'] && initPartnerId) {
                    objRes['partnerid'] = initPartnerId;
                }

                if (typeof objRes['partnerid'] !== 'undefined') {
                    objRes['partnerid'] = objRes['partnerid'].replaceAll('/','');
                    var temp = objRes['partnerid'].split('#');
                    objRes['partnerid'] = temp[0];
                }
                if (typeof objRes['starterid'] !== 'undefined') {
                    objRes['starterid'] = objRes['starterid'].replaceAll('/','');
                    var temp = objRes['starterid'].split('#');
                    objRes['starterid'] = temp[0];
                }


                var params = {};
                
                if (typeof(partnerLang) !== "undefined") {
                    params['lang'] = partnerLang;
                }
                for (var k in objRes) {
                    if (k == 'partnerid' || k == 'partnerlD') {
                        params['partnerID'] = objRes[k];
                        globalPartnerId = params['partnerID'];
                    }
                    if (k === "starterid") {
                        params["starterID"] = objRes[k];
                        globalStarterId = params["starterID"];
                    }
                    if (k == 'affil_nr') {
                        params['act_affil_nr'] = objRes[k];
                    }
                    if (k == 'uid') {
                        params['act_emp_hash'] = objRes[k];
                    }
                    if (k == 'id') {
                        params['id'] = objRes[k];
                    }
                    if (k == 'opt') {
                        params['act_opt'] = objRes[k];
                    }
                    if (k == 'lang') {
                        params['lang'] = objRes[k];
                    }
                    if (k == 'mi') {
                        params['mi'] = objRes[k];
                    }
                    if (k == 'contactgroupid') {
                        params['contactgroupid'] = objRes[k];
                    }
                    if (k == 'questionareid') {
                        params['questionareid'] = objRes[k];
                    }
                    if (k == 'redirect') {
                        params['redirect'] = objRes[k];
                    }
                    if (k == 'type') {
                        params['type'] = objRes[k];
                    }
                }

                if (Object.keys( params ).length > 0) {
                    params['nd'] = rnd;
                }

                return params;
            };
            this.urlEncodeData = function(data) {
                var query = [];
                if (data instanceof Object) {
                    for (var k in data) {
                        query.push(encodeURIComponent(k) + '=' +
                                    encodeURIComponent(data[k]));
                    }
                    return query.join('&');
                } else {
                    return encodeURIComponent(data);
                }
            }

            this.printLog = function(log) {
                var elemLog = document.createElement("div");
                elemLog.setAttribute('style', "width:200px; background-color:white; border:1px solid black; font-size:12px; float:right;");
                elemLog.innerHTML = log.join("<br>");
                document.body.appendChild(elemLog);
            }

            this.createElem = function (attr, container, onLoad) {
                var type = "iframe";

                elem = document.createElement(type);
                if (attr instanceof Object) {
                    for (var k in attr) {
                        elem.setAttribute(k, attr[k]);
                    }
                }

                var elemLoading = document.createElement("div");
                elemLoading.setAttribute('id', attr.id + "Loading");
                elemLoading.setAttribute('class', "partnerFrameLoading");
                elemLoading.innerHTML = "<div>Der Inhalt wird geladen...</div>";

                if (onLoad != undefined) {
                    if (elem.addEventListener) {
                        elem.addEventListener('load', onLoad, false);
                    } else if (elem.attachEvent) {
                        elem.attachEvent('onload', onLoad);
                    }
                }
                if (container) {
                    container.appendChild(elemLoading);
                    container.appendChild(elem);
                }
                else {
                    document.body.appendChild(elemLoading);
                    document.body.appendChild(elem);
                }
                return elem;
            };

            this.removeElem = function(elemid){
                element = document.getElementById(elemid);
                if (element) {
                    element.parentNode.removeChild(element);
                }
            };

            this.getContainer = function(elemid){
                if (frame === null && typeof(partnerFrameClass) !== "undefined") {
                        var frames = document.getElementsByTagName("iframe");
                        console.log(frames);
                        for (var i = 0; i < frames.length; i++) {
                            if (frames[i].getAttribute("class") == partnerFrameClass) {
                                frame = frames[i];
                                console.log(frame);
                                frame = (frame.contentWindow || frame.contentDocument);
                                if (frame.document) frame = frame.document;
                                break;
                            }
                        }
                }

                var res = null;
                if (frame) {
                    console.log(frame);
                    frame.contentDocument.getElementById(elemid);
                }
                else {
                    res = document.getElementById(elemid);
                }
                return res;
            };
            
            this.frameLoad = function(a) {
                var Loadingelem = document.getElementById(a.srcElement.getAttribute('id') + 'Loading');
                if (Loadingelem) {
                    Loadingelem.remove();
                }
                if (typeof(scrollContainer) != "undefined") {
                    document.getElementById(scrollContainer).scrollTop(0);
                    //$('#'+scrollContainer).scrollTop(0);
                }
                window.scrollTo(0,0);

                //h = this.contentWindow.document.body.scrollHeight + 50;
                //this.style.height = h + 'px';
                //this.parentNode.style.height = h + 'px';

            };

            if (!partnerParams) {
                partnerParams = this.getParams();
            }



            log.push("partnerID = " + partnerParams['partnerID']);
            log.push("starterID = " + partnerParams['starterID']);


                if (partnerLoaded==0 && ((typeof partnerParams['partnerID'] !== 'undefined' && partnerParams['partnerID']) || (typeof partnerParams['starterID'] !== 'undefined' && partnerParams['starterID']))) {
                    log.push("Affiliate started");

                    var attr = {
                        'id':"wbopartnertransfer"+rnd,
                        'src':scriptURL+"/affiliate?"+this.urlEncodeData(partnerParams),
                        'width':0,
                        'height':0,
                        'frameborder':0,
                        'style':"width:0;height:0;",
                        'class':"wbo-partnertransfer-iframe"
                    };
                    var xhr = new XHR();
                    xhr.open('GET', scriptURL+"/affiliate?"+this.urlEncodeData(partnerParams), true);
                    xhr.withCredentials = true;
                    xhr.onload = newWBOPartner.Send;
                    xhr.send();
                    partnerLoaded = 1;
                    return;
                }
                else {
                    partnerLoaded = 1;
                    if (typeof(partnerParams['partnerID'])=='undefined' && typeof(partnerParams['starterID'])=='undefined' && typeof restApiUrl !== 'undefined') {
                        log.push("Check globalPartnerId started");
                        log.push("globalPartnerId = " + globalPartnerId);
                        log.push("globalStarterId = " + globalStarterId);

                        if (globalPartnerId !== null && globalStarterId !== null) {
                            if (globalPartnerId !== '') {
                                partnerParams['partnerID'] = globalPartnerId;
                            }
                            else if (globalStarterId !== '') {
                                partnerParams['starterID'] = globalStarterId;
                            }
                        }
                        else {
                            log.push("RestApi started");
                            var xhr = new XHR();
                            xhr.open('POST', restApiUrl, true);
                            xhr.withCredentials = true;
                            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                            xhr.setRequestHeader('x-requested-with', 'XMLHttpRequest');
                            xhr.onload = function(){
                                globalPartnerId = '';
                                globalStarterId = '';
                                if (this.responseText) {
                                    log.push("RestApi response = " + this.responseText);
                                    var p = JSON.parse(this.responseText);
                                    if (p && typeof p.partnerid !== 'undefined') {
                                        globalPartnerId = p.partnerid;
                                    }
                                    if (p && typeof p.starterid !== "undefined") {
                                        globalStarterId = p.starterid;
                                    }
                                }
                                newWBOPartner.Send();
                            };
                            xhr.onerror = function() {
                                globalPartnerId = -1;
                                globalStarterId = -1;
                            }
                            xhr.send("action=get_partner");
                            return;
                        }
                    }

                    if ((globalPartnerId && globalPartnerId !== -1) || (globalStarterId && globalStarterId !== -1)) {
                        newWBOPartner.linksAddPartnerId(globalPartnerId,globalStarterId);
                        setInterval(()=>{newWBOPartner.linksAddPartnerId(globalPartnerId,globalStarterId)}, 1000);
                    }
                    this.removeElem("partnertransfer"+rnd);
                    var container = document.getElementById('wboActivationContainer');
                    if (container) {
                        var attr = {
                            "id":"wboActivationFrame"+rnd,
                            "src":scriptURL+"/confirmation?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container);
                    }

                    var container = this.getContainer("wboRegistrationContainer");
                    if (container) {
                        var attr = {
                            "id":"wboRegistrationFrame"+rnd,
                            "src":scriptURL+"/register?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;",
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboIntRegistrationContainer');
                    if (container) {
                        if (container.getAttribute("contactgroupid") && typeof partnerParams["contactgroupid"] === 'undefined') {
                            partnerParams["contactgroupid"] = container.getAttribute("contactgroupid");
                        }
                        if (container.getAttribute("questionareid") && typeof partnerParams["questionareid"] === 'undefined') {
                            partnerParams["questionareid"] = container.getAttribute("questionareid");
                        }
                        if (container.getAttribute("redirect") && typeof partnerParams["redirect"] === 'undefined') {
                            partnerParams["redirect"] = container.getAttribute("redirect");
                        }
                        if (container.getAttribute("type") && typeof partnerParams["type"] === 'undefined') {
                            partnerParams["type"] = container.getAttribute("type");
                        }
                        var attr = {
                            "id":"wboIntRegistrationFrame"+rnd,
                            "src":scriptURL+"/intregister?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboBuyerRegistrationContainer');
                    if (container) {
                        var attr = {
                            "id":"wboBuyerRegistrationFrame"+rnd,
                            "src":scriptURL+"/buyerregister?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboContactContainer');
                    if (container) {
                        var attr = {
                            "id":"wboContactFrame"+rnd,
                            "src":scriptURL+"/contact?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboFeedbackContainer');
                    if (container) {
                        var attr = {
                            "id":"wboContactFrame"+rnd,
                            "src":scriptURL+"/contact?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboPartnerboxContainer');
                    if (container) {
                        var attr = {
                            "id":"wboPartnerboxFrame"+rnd,
                            "src":scriptURL+"/partnerbox?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboPartnerboxLiteContainer');
                    if (container) {
                        var attr = {
                            "id":"wboPartnerboxLiteFrame"+rnd,
                            "src":scriptURL+"/partnerboxlite?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
                    var container = document.getElementById('wboDoubleOptContainer');
                    if (container) {
                        var attr = {
                            "id":"wboDoubleOptContainer"+rnd,
                            "src":scriptURL+"/newsletterfull?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }

                    var container = document.getElementById('wboDoubleOptContainerInline');
                    if (container) {
                        var attr = {
                            "id":"wboDoubleOptContainerInline"+rnd,
                            "src":scriptURL+"/newsletterinline?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }

                    var container = document.getElementById('wboDoubleOptContainerFullForm');
                    if (container) {
                        var attr = {
                            "id":"wboDoubleOptContainerFullForm"+rnd,
                            "src":scriptURL+"/newsletter?"+this.urlEncodeData(partnerParams),
                            "width":"100%",
                            "height":"100%",
                            "frameborder":0,
                            "style":"width:100%;height:100%;"
                        }
                        this.createElem(attr,container,this.frameLoad);
                    }
            }

            log.push("Send finshed");
            //.printLog(log);
            //console.log(log);


        }


        //this.Send();
    };
    
    /*
    var wbocookietest = wboGetCookie('wbocookietest');
    if (!wbocookietest) {
        wboSetCookie('wbocookietest', 1, 1)
        self.location.href = scriptURL+"/fix?from="+self.location.href;
    }
    function wboSetCookie(cname, cvalue, ex) {
        var d = new Date();
        d.setTime(d.getTime() + (ex*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }
    function wboGetCookie(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for(var i = 0; i <ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }
    */
}
    var newWBOPartner = new newwbopartner();

    if (typeof partnerId !== 'undefined' && partnerId) {
        newWBOPartner.setInitPartnerId(partnerId);
    }

    document.addEventListener("DOMContentLoaded", newWBOPartner.Send);

    //window.addEventListener("load", newWBOPartner.Send);

    window.addEventListener("message", function(event) {
        if (typeof partnerScriptURL !== 'undefined') {
            if (event.data.origin == partnerScriptURL.match(/^https?:\/\/[^/]+/)[0]) {
                window.location.href = event.data.url;
            }
        }

    }, false);


//}





